Copyright: Copyright © 1995 - QSD as, Oslo, Norway
Citation: sdfdfd


QuickReport
QuickReport for Delphi

About

QuickReport for Delphi is a package of several components to make it easy to include printed reports and print preview in your Delphi Programs.

Component overview

Licence terms

Registering your copy of QuickReport

QuickReport mailing list

Reporting bugs

Helpfile hint

All properties, events and methods description pages are grouped into browse sequences. I.e. using the prior or next button will bring up a related property, event or method for the component in question.


About
QuickReport

Version 0.95c


QuickReport Components
QuickReport Component Overview

Visible components

TQuickReport	Required on every form that needs QR printing functionallity.

TQRBand

TQRLabel

TQRDBText

TQRDetailLink

TQRMemo

TQRShape

TQRDBCalc

TQRPreview

TQRGroup

TQRSysData

Non visible components

TQRPrinter

TQRCustomControl


TQuickReport Component

Properties	Events	Methods

Unit

QuickRep

Description

TQuickReport is the main component handling all the printing and data functionallity. Normally you drop this component on to a form and set its DataSource property to a TTable or TQuery component containig the data you want to print. Add other components like TQRBand and TQRDBText to format the output.


TQRBand Component

Properties	Events

Unit

QuickRep

Description

You build your reports by creating different QRBands and putting visible QuickReport controls on them. There are several different band types, like detail band, page header band, page footer band and so on.


TQRLabel Component

Properties	Events	Methods

Unit

QuickRep

Description

The QRLabel component is used to display text on a report like column headings. The caption property can be changed in any events during report preparation. If you want a to output text from a data field use the QRDBText component instead.

In addition the QRLabel component has all the properties from the QRCustomControl component.


TQRDBText Component

Properties	Events

Unit

QuickRep

Description

Use this component to display any field from a dataset. Works much like a DBText components on forms. If datafield is a memo field, the detail band will stretch to make room for all lines in the memo.


TQRMemo Component

Properties	Methods

Unit

QuickRep

Description

Use the TQRMemo component when you need to print multiline text. ####


TQRShape Component

Properties	Events	Methods

Unit

QuickRep

Description


TQRDBCalc Component

Properties

Unit

QuickRep

Description

This component automates the process of suming and counting of data fields. In addition to these properties the QRDBCalc has all the properties and events it inherits from TQRDBText.


TQRPrinter

Properties	Events	Methods

Unit

QuickRep

Description

TQRPrinter is a low level printer object with preview, save and load capabilities. An instance of this object called QRPrinter is automatically created when you application starts.

QRPrinter is like a Printer object with recording capabilities. All print commands you send to its Canvas property are recorded in a Windows Metafile object. If you use the NewPage method the current page is kept in memory and QRPrinter creates a new on. When you have created the entire printout you can choose to preview, print or save the result.

QuickReport uses this object for all its printing.


TQRPreview Component

Properties	Events	Methods

Unit

QuickRep

Description


Registering

QuickReport for Delphi will be freeware until version 1.0. From then on QuickReport will be shareware and there will be a registration fee of US $65 or NOK400 (Norwegian kroner).  Registered users will receive full source code and will be entitled to royalty free use and distribution of QuickReport in their own programs. Version 0.95a is free to use in your programs.

Payment can be done in one of the following ways:

- Include cash or International Money order with the above registration form

- Include check with the above registration form. Please add $10 handling fee

- Include EuroCheck. Please send NOK, not US$

- Make a S.W.I.F.T. transfer from your bank to the following bank account:
swift code: XIAN NO KK  account no: 6030 05 47055
Send registration form in separate mail.

S.W.I.F.T is the fastest way, usually I will get a next day notification.

If you distribute QuickReport you must do so without changing anything in the original QuickReport zip file. You use this program at your own risk. I am not responsible for any loss or damage caused by the use of QuickReport. QuickReport is copyright 1995 Allan Lochert.

Registration form


TQRGroup Component

Properties	Events	Methods

Unit

QuickRep

Description

There are two ways of printing master/detail reports with QuickReport. One is to use a TQuery component with a join Query and QRGroups to group the data. The other method is to use the TQRDetailLink component combined with DetailGroup bands. Each method has its unique strengths.

If you want master/detail reports with more than two ‘layers’ then using QRGroup and TQuery will probably be the best approach. For simple one level master detail reports or reports with several tables at the same level see the QRDetailLink component.


TQRSysData Component

Properties	Events	Methods

Unit

QuickRep

Description


TQuickReport Properties
Properties

Colomns

DataSource

DisplayPrintDialog

LeftMarginInches

LeftMarginMM

Orientation

PrintOrder

PageCount

PageHeight

PageNumber

PageWidth

RecordCount

RecordNo

ReportTitle

ReportType

RestartData

ShowProgress

SQLCompatible

TitleBeforeHeader


TQRSysData Properties
Properties

Alignment nei

AlignToBand

AutoSize

Color

TQRSysDataType

Font

Text

Transparent


TQRSysData property AlignToBand
AlignToBand Property

Applies to

TQRSysData

Declaration


TQuick Report Events
Events

AfterDetail

AfterPrint

BeforeDetail

BeforePrint

OnEndPage

OnNeedData

OnStartPage


TQuickReport method Preview
Preview Method

Applies to

TQuickReport

Declaration

procedure Preview

The Preview method first prepares the report if necessary, then calls the QRPrinter.Preview method. If you haven’t assigned an event handler for the QRPrinter.OnPreview event the standard preview form is displayed. Otherwise your OnPreview event handler is called. The report is finally freed from memory before returning.


TQuickReport Methods
Methods

Prepare

Preview

Print


TQuickReport method Prepare
Prepare Method

Applies to

TQuickReport

Declaration

procedure Prepare

Call the prepare method if you want to create the report without automatically printing or previewing it. Prepare create the report and sends it to the QRPrinter object.


TQRBand Properties
Properties

BandType

Color

Enabled

Font

ForceNewPage

Frame

Ruler

Width


TQRLabel Properties
Properties

Alignment

AutoSize

Caption

AlignToBand

Color

Font

Transparent


TQRBand event AfterPrint
AfterPrint Event

Applies to

TQRBand

Declaration

property AfterPrint : procedure (BandPrinted : Boolean) of object

This event is called whenever the band has been printed or tried to be printed but stopped in the BeforePrint event. The BandPrinted parameter will tell if the band was actually printed or not.


TQRBand Events
Events

AfterPrint

BeforePrint


TQRLabel Events
Events

OnPrint


TQRDBText Event OnPrint

Applies to

TQRDBText

Declaration

event OnPrint(Sender : TObject; var Value : String)

Called immediately before the component is printed. The string to be printed is in the value parameter and any changes to this string will not be stored to the record.


TQRDBText Properties
Properties

Alignment

AutoSize

DataSource

DataField

Font

Transparent


TQRDBText Events
Events

OnPrint


TQRDBText Property Alignment
Alignment Property

Applies to

TQRDBText

Declaration

property Alignment : (taCenter,taLeftJustify,taRightJustify)

Control alignment of the text within the control


TQRDBText Property AutoSize
AutoSize Property

Applies to

TQRDBText

Declaration

property AutoSize : boolean

If true, the control will resize to the width needed for the caption


TQRDBText Property DataSource
DataSource Property

Applies to

TQRDBText

Declaration

property DataSource : TDataSource

DataSource to pick field from


TQRDBText Property DataField
DataField Property

Applies to

TQRDBText

Declaration

property DataField : String

The field to display.


TQRDBText Property Font
Font Property

Applies to

TQRDBText, TQRMemo

Declaration

property Font : TFont

Use to control the font, style and size of the text. Best results are obtained using a TrueType font. If you experience some scaling problems in the preview window change the font to one contailing the TT prefix.


TQRDBText Property Transparent
Transparent Property

Applies to

TQRDBText

Declaration

property Transparent : Boolean

If true, text background will be transparent, i.e. any components in the background will be visible.


TQuickReport Property PageHeight
PageHeight Property

Applies to

TQuickReport

Declaration

property PageHeight : Longint read only

The current page height, taken from the QRPrinter object.


TQuickReport Property DataSource
DataSource  Property

Applies to

TQuickReport

Declaration

property DataSource : TDatasource

Set the DataSource property to the datasource you print the records from. QuickReport automatically advances through this dataset and prints a set of detail bands for each record. If you don’t spesify a DataSource and not a OnNeedData event handler only one set of detail bands will be printed. Also see the OnNeedData event and RestartData property.


TQuickReport property PageWidth
PageWidth Property

Applies to

TQuickReport

Declaration

property PageWidth : Longint read only

The current page width, taken from the QRPrinter object.


TQRBand Property Width
Width Property

Applies to

TQRBand and all other visible components

Declaration

#####Find me


TQuickReport property ShowProgress
ShowProgress Property

Applies to

TQuickReport

Declaration

property ShowProgress : boolean

If True (Default) a progress form will appear during report preparation and printing. The progress form has a Cancel button.


TQuickReport property Orientation
Orientation Property

Applies to

TQuickReport

Declaration

property Orientation : TPrinterOrientation

Selects the paper orientation. Orientation can be set to poPortrait and poLandscape. Please note that the TPrinterOrientation type is declared in the Printer unit. If you want to set this property you need to include the printer unit in your uses clause.


TQRLabel Property Alignment

Applies to

TQRLabel

Declaration

property Alignment : (taRight, taLeft, taCenter)

Sets the alignment of the text within the given rectangle or QRLabel position inside a QRBand. See AlignToBand.


TQRLabel Property AutoSize

Applies to

TQRLabel

Declaration


TQRLabel Property Caption

Applies to

TQRLabel

Declaration

property Caption

Caption contains the actual text to be printed.


TQRLabel Property AlignToBand

Applies to

TQRLabel

Declaration

property AlignToBand

Controlls the effect of the Alignment property

True	The QRLabel component will be aligned left, centered or right inside the extents of the QRBand.

False	Only the text inside the components will be aligned. (Default)


TQRLabel Property Color

Applies to

TQRLabel

Declaration

property Color

The background color of the text. Se also the Transparent property.


TQRLabel Property Font

Applies to

TQRLabel

Declaration

property Font

If you want to use another font than the default for the form or QRBand set the Font property.

Tip

Best results are obtained using TrueType fonts. If you experience some scaling problems in the preview window change the font to one contailing the TT prefix.


TQRLabel Property Transparent

Applies to

TQRLabel

Declaration

property Transparent

If Transparent is False (default) the bacground of the text will be painted before the text is drawn. If Transparent is True, the background will not be painted.


TQRLabel Event OnPrint


TQRMemo Properties
Properties

Font

Lines

ParentReport

WordWrap


TQRShape Properties
Properties

Brush

Height

Pen

Shape

Width


TQRShape property Brush
Brush Property

Applies to

TQRShape

Declaration

property Brush : TBrush


TQRShape property Height
Height Property

Applies to

TQRShape

Declaration

property Height default 65;


TQRShape property Pen
Pen Property

Applies to

TQRShape

Declaration

property Pen : TPen


TQRShape property Shape
Shape Property

Applies to

TQRShape

Declaration

Property Shape : TQRShapeType Read FShape write SetShape;

TQRShapeType:

Value	Meaning

qrsRectangle

qrsCircle

qrsVertLine

qrsHorLine


TQRShape property Width
Width Property

Applies to

TQRShape

Declaration


QuickReport Mailing List

If you want to receive a notification when new releases of QuickReport is available send a mail to

quickreport@u9.oslohd.no

with SUBSCRIBE QUICKREPORT as message subject.


TQRDBCalc Properties
Properties

AsInteger

AsReal

Operation

PrintMask

ResetGroup


TQRDBCalc property Operation
Operation Property

Applies to

TQRDBCalc

Declaration

property Operation : (qrcSUM,qrcCOUNT)

Set the operation you want to perform.


TQRDBCalc property PrintMask
PrintMask Property

Applies to

TQRDBCalc

Declaration

property PrintMask : String

Use the PrintMast to format the output of the QRDBCalc component. Look up the FormatFloat procedure in Delphi help for documentation on how the PrintMask works.


TQRDBCalc property ResetGroup
ResetGroup Property

Applies to

TQRDBCalc

Declaration

property ResetGroup : TQRGroup

The QRDBCalc will be reset when the group it is connected to breaks.


TQRDBCalc property AsInteger
AsInteger Property

Applies to

TQRDBCalc

Declaration

property AsInteger : Longint read only

Returns the current value of the QRDBCalc component as an Integer.


TQRDBCalc property AsReal
AsReal Property

Allpies to

TQRDBCalc

Declaration

property AsReal : real read only

Returns the current value of the QRDBCalc component as a Real.


TQRDetailLink Component

Properties	Events

Unit

QuickRep

Description

QRDetailLink is the second way of creating master/detail reports with QuickReport. Typically you will use QRDetailLink with a TTable (or TQuery) when you have only two levels of linking. The strength of QRDetailLink however, is that you can have as many detail tables you want at the same level.


TQRPrinter Properties
Properties

Canceled

Canvas

EnableOpenBtn

EnablePrintBtn

EnableSaveBtn

ToPage

FromPage

Orientation

Page

PageHeight

PageCount

PageNumber

PageWidth

ShowProgress

Status

Title

Thumbs


TQuickReport Property PageCount
PageCount  Property

Applies to

TQuickReport

Declaration

property PageCount : Longint read only

The total number of pages in the report. This property is not valid before the report is finished.


TQRPrinter Events
Events

OnPreview


TQRPrinter Event OnPreview

Applies to

TQRPrinter

Declaration

property OnPreview : procedure of object

Use this event if you want to display your own preview form instead of the standard included with QuickReport. Creating a custom preview is very easy using the supplied TQRCustomPreview component. See the demo program for an example on how to do this.


TQRPrinter property Canceled
Canceled Property

Applies to

TQRPrinter

Declaration

property Canceled : boolean

True if the Cancel method has been called. This can be used to check if users pressed a Cancel button.


TQRPrinter property Canvas
Canvas Property

Applies to

TQRPrinter

Declaration

property Canvas : TCanvas

This is the canvas you use to do your printing. It understands all standard Tcanvas commands except those that returns information, like TextWidth.


TQRPrinter property EnableOpenBtn
EnableOpenBtn Property

Applies to

TQRPrinter

Declaration

property EnableOpenBtn : boolean

If True, the Open file button will appear on the standard preview form.


TQRPrinter property EnablePrintBtn
EnablePrintBtn Property

Applies to

TQRPrinter

Declaration

property EnablePrintBtn : boolean

If True, the Print button will appear on the standard preview form.


TQRPrinter property EnableSaveBtn
EnableSaveBtn Property

Applies to

TQRPrinter

Declaration

property EnableSaveBtn : boolean

If True, the Save file button will appear on the standard preview form.


TQRPrinter property ToPage
ToPage Property

Applies to

TQRPrinter

Declaration

property ToPage : integer

Specify the last page to be printed.


TQRPrinter property FromPage
FromPage Property

Applies to

TQRPrinter

Declaration

property FromPage : integer

Specify the first page to be printed.


TQRPrinter property Orientation
Orientation Property

Applies to

TQRPrinter

Declaration

property Orientation : TPrinterOrientation

Set to poPortrait or poLandscape to select printer orientation.


TQRPrinter property Page
Page Property

Applies to

TQRPrinter

Declaration

property Page : TMetafile  read only

This is a metafile representation of the currently selected page. Status must be mpFinished for this metafile to be valid.


TQRPrinter property PageHeight
PageHeight Property

Applies to

TQRPrinter

Declaration

property PageHeight : integer read only

The current page height in pixels.


TQRPrinter property PageCount
PageCount Property

Applies to

TQRPrinter

Declaration

property PageCount : Integer read only

Total number of pages sent to the QRPrinter in the current print job.


TQRPrinter property PageNumber
PageNumber Property

Applies to

TQRPrinter

Declaration

property PageNumber : integer

Select the page you want QRPrinter to make available for viewing or copying to clipboard. The Status property must be mpFinished.


TQRPrinter property PageWidth
PageWidth Property

Applies to

TQRPrinter

Declaration

property PageWidth : integer read only

The current page width in pixels.


TQRPrinter property ShowProgress
ShowProgress Property

Applies to

TQRPrinter

Declaration

property ShowProgress : boolean

If true a progress form will appear indicating the progress of printing, saving and loading. The form has a Cancel button and the Cancelled property will be set to true if the user presses this button.


TQRPrinter property Status
Status Property

Applies to

TQRPrinter

Declaration

property Status : TQRPrinterStatus read only

Indicates the current QRPrinter status. It can be one of the following:

Value	Meaning

mpReady	QRPrinter is ready to accept a new print job

mpBusy	A print job is currently being recorded

mpFinnished	The print job has been ended

mpPrinting	QRPrinter is sending a job to the printer

mpPreviewing	A preview is currently active


TQRPrinter property Title
Title Property

Applies to

TQRPrinter

Declaration

property Title : String

The current print job title. This title will appear in the print manager and in any network print queue.


TQRPrinter property Thumbs
Thumbs Property

Applies to

TQRPrinter

Declaration

property Thumbs : integer

QRPrinter can print several scaled down images of pages on each sheet of paper. If you set Thumbs to two QRPrinter will print two by two images, if you set it to three, three by three images will be printed and so on.


TQRPreview Properties
Properties

PageNumber

ScrollDown

ScrollLeft

Zoom


TQRPreview Events
Events

Show


TQRPreview event Show


TQRPrinter Methods
Methods

BeginDoc

Cancel

Cleanup

CopyPageToClipBoard

EndDoc

Load

NewPage

Preview

Print

Save


TQRPrinter procedure BeginDoc
BeginDoc Procedure

Applies to

TQRPrinter

Declaration

procedure BeginDoc

Start a new print job. This sets the Status property to mpBusy.


TQRPrinter procedure Cancel
Cancel Procedure

Applies to

TQRPrinter

Declaration

procedure Cancel

Cancel the current print job. This sets the Status property to mbReady


TQRPrinter procedure Cleanup
Cleanup Procedure

Applies to

TQRPrinter

Declaration

procedure Cleanup

After you are finished with the current print job this command will free all pages from memory. This sets the Status property to mpReady.


TQRPrinter procedure CopyPageToClipBoard
CopyPageToClipBoard Procedure

Applies to

TQRPrinter

Declaration

procedure CopyPageToClipBoard

Copy the currently selected page to the clipboard. This requires that EndDoc has been called.


TQRPrinter procedure EndDoc
EndDoc Procedure

Applies to

TQRPrinter

Declaration

procedure EndDoc

Tells QRPrinter that the you are finished sending commands to the canvas. This sets the Status property to mpFinished.


TQRPrinter procedure Load
Load Procedure

Applies to

TQRPrinter

Declaration

procedure Load(Filename : String)

Loads a previously saved printout from a file.


TQRPrinter procedure NewPage
NewPage Procedure

Applies to

TQRPrinter

Declaration

procedure NewPage

Tells QRPrinter to start printing a new page. The current page is kept in memory and a new one is created. Page number is increased by one. This requires the Status property to be mpBusy.


TQRPrinter procedure Preview
Preview Procedure

Applies to

TQRPrinter

Declaration

procedure Preview

This brings up print preview. It requires the Status property to be mbFinished. If you have assigned an event handler to the OnPreview event this gets called and nothing else is done.


TQRPrinter procedure Print
Print Procedure

Applies to

TQRPrinter

Declaration

procedure Print

This prints the current report. It requires the Status property to be mpFinished.


TQRPrinter procedure Save
Save Procedure

Applies to

TQRPrinter

Declaration

procedure Save(Filename : String)

This saves the current report to a file. The Status property must be mpFinished. The file format is a QuickReport internal format. Documentation for this will be released later.


Registration form
QuickReport version 0.95c Registration Form

______________

Date

______________________________________________________________

Name/contact

______________________________________________________________

Postal address

_______________________________________________

zip/city

_______________________________________________

Country

_______________________________________________

E-mail address

Send source code by postal mail instead of e-mail ? _______ (+ $5 postage/handling)

________________________________________________

Signature

Registration fee is US $65 or NOK400.

Registered users will get access to download the QuickReport source code for any 0.9x and 1.x version.

If you register a beta version (0.9x) you have the same upgrade rights as of version 1.0.

Fill out the above registration form and send it to :

   Allan Lochert

   Uranienborgvn. 9a

   N-0351 Oslo

   Norway


TQRGroup Properties
Properties

DataField

DataSource

FooterBand

HeaderBand

Level

GroupData

HeaderPrinted

PrintNewHeader


TQRGroup Events
Events

OnNeedData


TQRGroup property DataSource
DataSource Property

Applies to

TQRGroup

Declaration

property DataSource : TDataSource

Select the datasource you want to connect this group to.


TQRGroup property DataField
DataField Property

Applies to

TQRGroup

Declaration

property DataField : String

Select the data field you want to connect this group to. The group will reprint when the value of Datafield change or a higher level group is reprinted.


TQRGroup Property FooterBand
FooterBand Property

Applies to

TQRGroup

Declaration

Property FooterBand : TQRBand

Select a band to be printed as this groups footer band.


TQRGroup Property HeaderBand
HeaderBand Property

Applies to

TQRGroup

Declaration

Property HeaderBand : TQRBand

Selects a band to be printed as this groups header band.


TQRGroup Property Level
Level Property

Applies to

TQRGroup

Declaration

Property Level : Integer

This group’s level. The outer (highest) level is 0, the inner (lowest) level is 9.


TQRGroup Event OnNeedData
OnNeedData Event

Applies to

TQRGroup

Declaration

Property OnNeedData : procedure (var Value : String) of object


TQRGroup Methods
Methods


TQRGroup Property GroupData
GroupData Property

Applies to

TQRGroup

Declaration

Property GroupData : String


TQRGroup Property HeaderPrinted
HeaderPrinted Property

Applies to

TQRGroup

Declaration

Property HeaderPrinted : Boolean


TQRGroup Property PrintNewHeader
PrintNewHeader Property

Applies to

TQRGroup

Declaration

Property PrintNewHeader : Boolean read


TQRSysData Events
Events

OnPrint


TQRSysData event OnPrint


TQRSysData property Alignment
Alignment Property

Applies to

TQRSysData

Declaration


TQRSysData property AutoSize
AutoSize Property

Applies to

TQRSysData

Declaration


TQRSysData property Color
Color Property

Applies to

TQRSysData

Declaration


TQRSysData property TQRSysDataType
TQRSysDataType Property

Applies to

TQRSysData

Declaration

property Data : TQRSysDataType

The Data property decides what information the component will display.

Value	Meaning

qrsTime	Current time in the format HH:MM

qrsDate	Current date in the format set by the global ShortDateFormat variable

qrsDateTime	Current date and time separated by a comma

qrsPageNumber 	The current page number

qrsPageCount	Total number of pages in the report.
Note - as of version 0.95c this is not implemented yet

qrsReportTitle	The report title as it appears in the TQuickReport.ReportTitle property

qrsDetailCount	Total number of records to be printed in report

qrsDetailNo	Current record number to be printed


TQRSysData property Font
Font Property

Applies to

TQRSysData

Declaration


TQRSysData property Text
Text Property

Applies to

TQRSysData

Declaration


TQRSysData property Transparent
Transparent Property

Applies to

TQRSysData

Declaration


TQuickReport Event AfterPrint
AfterPrint Event

See also	Example

Applies to

TQuickReport

Declaration

property AfterPrint : TNotifyEvent

The AfterPrint event is called when the report is prepared and sent to the QRPrinter object.


TQuickReport Event BeforeDetail
BeforeDetail Event

See also	Example

Applies to

TQuickReport

Declaration

property BeforeDetail : TNotifyEvent

The BeforeDetail event is called before the detail bands for a record are printed.


TQuickReport Event AfterDetail
AfterDetail Event

See also	Example

Applies to

TQuickReport

Declaration

property AfterDetail : TNotifyEvent

The AfterDetail event is called after the detail bands for one record are printed.


TQuickReport method Print
Print Method

Applies to

TQuickReport

Declaration

procedure Print

The Print method first prepares the report if necessary, sends it to the QRPrinter object, and then calls the QRPrinter.Print methods. The Report is finally freed from memory.


TQRCustomControl Component
TQRCustomControl

Properties	Methods

Unit

QuickRep

Description

The QRCostomControl component is the base class for all printable QuickReport components. If you want to create your own printable components you should make them children of this class. QRCustomControl has two virtual methods you might override.


TQRBand property BandType
BandType Property

Applies to

TQRBand

Declaration

property BandType : TQRBandType

BandType selects when this band will be printed.

TQRBandType

rbTitle	This band is printed once at the start of the report. The QuickReport.TitleBeforeHeader property decides if the PageHeader or Title band will appear first.

rbPageHeader	Page header bands appear on top of each page. The QuickReport.TitleBeforeHeader property decides which band will be printed first on the first page. You can have as many Page header bands you want.

rbDetail	The Detail band gets printed once for every record in your dataset. If you design a master/detail report using the QRDetailLink component this band will be the detail band for your master table. You can have as many detail bands you want.

rbDetailGroup	If you create a master/detail report using the QRDetailLink component then this band will be the Detail band for your Detail Table(s). You must connect the DetailGroup band to the DetailLink component using the QRDetailLink.DetailBand property. This band can also be used as header and footer bands for the QRDetailLink component.

rbPageFooter	This band is printed on the bottom of every page.

rbSummary	The Summary band is printed on the last page of the report, after all detail bands and group footers.

rbGroupHeader

rbGroupFooter

rbColumnHeader	If you print a multi column report this band will be printed on top of each column.

rbOverlay	If you want some static text or graphic to be printed on every page of your reports then you can use the rbOverlay band. This band will be printed once on each page and it overlay all other text and graphic printed on the page.


TQRBand property Color
Color Property

Applies to

TQRBand

Declaration

property Color

Sets the background color of the band.


TQRBand property Enabled
Enabled Property

Applies to

TQRBand

Declaration

property Enabled : Boolean

Enables and disables the printing of this band. If this property is false the BeforePrint and AfterPrint events will be skipped. You can change this property during report progress, for instance to print different detail bands depending on the type of data to print.


TQRBand property Font
Font Property

Applies to

TQRBand

Declaration

property Font

The default font for the band. Use a True Type font to ensure that QuickReport is able to scale the font properly during preview.


TQRBand property ForceNewPage
ForceNewPage Property

Applies to

TQRBand

Declaration

property ForceNewPage : Boolean

##### find me!


TQRBand property Frame
Frame Property

Applies to

TQRBand

Declaration

property Frame : TPen

##### find me!


TQRBand property Ruler
Ruler Property

Applies to

TQRBand

Declaration

property Ruler : TQRRuler

This property will tell QuickReport to display a ruler in the background of the band during design time. This will help you position the controls on the bands. One of the following values can be set:

TQrRuler

qrrNone	No ruler is displayed

qrrInchesH	Horizontal ruler lines every inch

qrrInchesV	Vertical ruler lines every inch

qrrInchesHV	Horizontal and vertical ruler lines every inch

qrrCmH	Horizontal rulers every centimetre

qrrCmV	Vertical ruler lines every centimetre

qrrCmHV	Horizontal and vertical ruler lines every centimetre


TQRBand event BeforePrint
BeforePrint Event

Applies to

TQRBand

Declaration

property BeforePrint : procedure (var PrintBand : Boolean) of object

The BeforePrint event is called before the band is about to be printed. You can set the PrintBand parameter to false if you want the band to be skipped for this time.


TQuickReport Event BeforePrint
BeforePrint Event

See also	Example

Applies to

TQuickReport

Declaration

property BeforePrint : TNotifyEvent

The BeforePrint event is called before the report is prepeared.


TQuickReport Event OnEndPage
OnEndPage Event

See also	Example

Applies to

TQuickReport

Declaration

property OnEndPage : TNotifyEvent

The OnEndPage event is called whenever a page brake is about to be performed.


TQuickReport Event OnNeedData
OnNeedData Event

See also	Example

Applies to

TQuickReport

Declaration

property OnNeedData : procedure (var MoreData : Boolean) of object

The OnNeedData event is used if you want to print a report of data not coming from a regular DataSource, but from arrays, variables, text files or whatever you like. If you leave the DataSource property blank and instead write an OnNeedData event handler this handler gets called whenever QuickReport is going to print a new set of detail bands. Set the MoreData parameter to false when you are printing the last set of data.


TQuickReport Event OnStartPage
OnStartPage Event

See also	Example

Applies to

TQuickReport

Declaration

property OnStartPage : TNotifyEvent

The OnStartPage event is called whenever a new page is started.


TQuickReport Property PageNumber
PageNumber Property

Applies to

TQuickReport

Declaration

property PageNumber : Longint read only

The current page number. This property can be access in events during report preparation.


TQuickReport Property RecordCount
RecordCount Property

Applies to

TQuickReport

Declaration

property RecordCount : Longint read only

The total number of records in the master dataset. Se also the SQLCompatible property.


TQuickReport Property RecordNo
RecordNo Property

Applies to

TQuickReport

Declaration

property RecordNo : longint read only

The current record in the dataset. If you are printing a master/detail report using the QRDetailLink component this property indicates the record number in the master table.


TQuickReport Property DisplayPrintDialog
DisplayPrintDialog Property

Applies to

TQuickReport

Declaration

property DisplayPrintDialog : Boolean

If DisplayPrintDialog is set to True a print dialogue will appear before the report is printed. This dialogue will let the user select printer, pages to print and print to file.


TQuickReport Property Colomns
Colomns Property

Applies to

TQuickReport

Declaration

property Columns : integer

The Columns property can be used to print multi column mailing labels or phone directory style reports. Use the PrintOrder property to set way records will print. Also se the QRBand.BandType=rbColumnHeader.


TQuickReport Property LeftMarginInches
LeftMarginInches Property

Applies to

TQuickReport

Declaration

property LeftMarginInches : Longint

The left margin in 1/10th inches


TQuickReport Property LeftMarginMM
LeftMarginMM Property

Applies to

TQuickReport

Declaration

property LeftMarginMM : Longint

The left margin in millimetres


TQuickReport Property PrintOrder
PrintOrder Property

Applies to

TQuickReport

Declaration

property PrintOrder : (ColByCol, RowByRow)

PrintOrder is used to set how the text will flow on a multi column report. Text can be printed column by column or row by row.

Note - RowByRow will be ignored in version 0.95c of QuickReport


TQuickReport Property ReportTitle
ReportTitle Property

Applies to

TQuickReport

Declaration

property ReportTitle : String

The ReportTitle will appear in the Print Manager and in any network printing queue. It will also printed wherever you have used a TQRSysData component set to display ReportTitle.


TQuickReport Property ReportType
ReportType Property

Applies to

TQuickReport

Declaration

property ReportType : (qrStandard, qrMasterDetail)

Set ReportType to qrMasterDetail if you want QuickReport to print the detail tables you have linked using the QRDetailLink component.

Value	Meaning

qrStandard	Standard report listing from a table or query

qrSingleDetail	??

qrMasterDetail	Master detail using QRDetailLink components.


TQuickReport Property RestartData
RestartData Property

Applies to

TQuickReport

Declaration

property RestartData : Boolean

If True (default) QuickReport will move to the first record in the dataset before printing starts. If False, printing will start at the current record.


TQuickReport Property SQLCompatible
SQLCompatible Property

Applies to

TQuickReport

Declaration

property SQLCompatible : boolean

Not all Databases support the RecordCount function. If you get an error message saying ‘function not supported’ try setting the SQLCompatible to True.


TQuickReport Property TitleBeforeHeader
TitleBeforeHeader Property

Applies to

TQuickReport

Declaration

property TitleBeforeHeader : boolean

If False (Default) the page header will be printed before the Title band on the first page. You can reverse this by setting the TitleBeforeHeader property to True.


TQRCustomControl Methods
Methods

Print

Stretch


TQRCustomControl method Print
Print Method

Applies to

TQRCustomControl

Declaration

procedure Print(X,Y : Integer); virtual

The Print method prints the component to the QRPrinter object at the given position. The default print method prints the text of the protected Caption property. If you want another behaviour you will need to override this method.


TQRCustomControl method Stretch
TQRCustomControl Stretch

Applies to

TQRCustomControl

Declaration

procedure Stretch(var size : Integer); virtual

If your component will resize itself vertically at printing time, like a stretching memo field you must return the new component height with this method. If your component will have a static size you won't use this method.


TQRCustomControl Properties
Properties

AutoSize

Height

Left

Top

Visible

Width


TQRCustomControl property AutoSize
AutoSize Property

Applies to

TQRCustomControl

Declaration

property AutoSize


TQRCustomControl property Height
Height Property

Applies to

TQRCustomControl

Declaration

property height

The height of the control in pixels.


TQRCustomControl property Left
Left Property

Applies to

TQRCustomControl

Declaration

Property Left

The left horizontal position of the control in pixels, counting from the left margin.


TQRCustomControl property Top
Top Property

Applies to

TQRCustomControl

Declaration

property Top

The vertical position of the control within the band it is printed on.


TQRCustomControl property Visible
Visible Property

Applies to

TQRCustomControl

Declaration

property Visible

If True (default) the control is printed. If False, the control is not printed.


TQRCustomControl property Width
Width Property

Applies to

TQRCustomControl

Declaration

property width

The width of the control in pixels.


TQRDetailLink Properties
Properties

DataSource

DetailBand

FooterBand

HeaderBand


TQRDetailLink Property DataSource
DataSource Property

Applies to

TQRDetailLink

Declaration

property DataSource : TDataSource

The datasource to connect this QRDetailLink to


TQRDetailLink Property DetailBand
DetailBand Property

Applies to

TQRDetailLink

Declaration

property DetailBand : TQRBand

The band to use as this QRDetailLink’s Detail band. It is printed for every record in the detail table maching with the current master record, provided you have set up the master/detail relationship correctly of course. Se the Delphi manuals for help on how to do this if you are unsure.


TQRDetailLink Property FooterBand
FooterBand Property

Applies to

TQRDetailLink

Declaration

property FooterBand : TQRBand

The band to use as this QRDetailLink’s footerl band. The footer band is printed after all detail records for the current master record.


TQRDetailLink Property HeaderBand
HeaderBand Property

Applies to

TQRDetailLink

Declaration

property HeaderBand : TQRBand

The band to use as this QRDetailLink’s Detail band


TQRDetailLink Events
Events

OnNeedData


TQRDetailLink Event OnNeedData
OnNeedData Event

Applies to

TQRDetailLink

Declaration

Property OnNeedData : procedure (var MoreData : Boolean) of object

If you want to print from an array or some other source except a DataSource you can use the OnNeedData event to retrieve the information. See the QuickReport.OnNeedData event for a more in depth explanation on this.


TQRDBMemo property ParentReport
ParentReport Property (public)

Applies to

TQRMemo

Declaration

property ParentReport : TQuickReport

#####


TQRPreview Methods
Methods

ZoomToWidth

ZoomToFit

UpdateZoom


TQRPreview Method ZoomToWidth
ZoomToWidth Method

Applies to

TQRPreview

Declaration

procedure ZoomToWidth;


TQRPreview Method ZoomToFit
ZoomToFit Method

Applies to

TQRPreview

Declaration

procedure ZoomToFit;


TQRPreview Method UpdateZoom
UpdateZoom Method

Applies to

TQRPreview

Declaration

procedure UpdateZoom;